;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; 01_stacks_3.lisp 
;;;

;;
;; REPL
;;

(defun read-input-str ()
  (let ((line (read-line)))
    (if (eql (length line) 0)
        ""
      (format nil "~a ~a" line (read-input-str)))))

(defun read-code (&optional (string (read-input-str)))
  (let ((eof-val (gensym)))
    (with-input-from-string (stream string)
      (labels ((read-elems ()
                 (let ((res (read stream nil eof-val)))
                   (unless (eql res eof-val)
                     (cons res (read-elems))))))
        (read-elems)))))

(defun stacks-repl ()
  (loop (format t "~%stacks > ") 
        (handler-case (print (apply #'execute (read-code)))
          (error (err) (format t "Chyba: ~a" err)))))


;;
;; Drobnosti
;;


;; Slovo na tisk
;; ( a -- a)    
(defprim :print
  (print (car *rslt*)))

#|
1 :print
|#

;; Negace (a -- negace a)
(define-word :not '(:if t :else nil :then))


;;
;; Nastavení hodnoty vazby
;;

#|
Pomocná funkce, která změní hodnotu proměnné ve slovníku.
Budeme ji používat na zásobník *bnd*.

Funkce je velmi podobná funkci dict-find ze souboru 01_stacks_1.lisp
Bylo by dobré to sjednotit.
|#

(defun dict-set (key val dict)
  (let ((pair (find key dict :key #'car)))
    (unless pair (error "Key not found in dictionary: ~s" key))
    (setf (cdr pair) val)))

;; Nastavení hodnoty proměnné
;; hodnotu nechává na zásobníku
(defprim :set!
  (dict-set (pop *rslt*) (car *rslt*) *bnd*))


;;
;; Nerovnosti
;;

;; (a b -- log. hodnota a < b)
(defprim :<
  (word-bin-op #'<))

;; (a b -- log. hodnota a > b)
(defprim :>
  (word-bin-op #'>))

;; (a b -- log. hodnota a <= b)
(defprim :<=
  (word-bin-op #'<=))

;; (a b -- log. hodnota a >= b)
(defprim :>=
  (word-bin-op #'>=))

;;
;; Cykly
;;

;; Slovo uloží programový zásobník na vrch návratového zásobníku.
(defprim :lbl
  (push *exec* *ret*))

;; Slovo odebere hodnotu z datového zásobíku.
;; Pokud je odebraná hodnota Pravda, nastaví programový zásobník na vrchol návratového zásobníku.
;; Jinak odebere prvek z návratového zásobníku
(defprim :cjmp
  (if (pop *rslt*)
      (setf *exec* (first *ret*))
    (pop *ret*)))


#|
;; Stack

5 :lbl :print 1 :- :dup 0 :> :cjmp
|#





